<?php

use yii\db\Schema;
use yii\db\Migration;

class m150316_111032_create_reviews_table extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%reviews}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%reviews}}", [
            'id'                    => Schema::TYPE_PK,

            'created_by'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_by'            => Schema::TYPE_INTEGER . ' NULL',

            'created_at'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_at'            => Schema::TYPE_INTEGER . ' NULL',

            'name'                  => Schema::TYPE_STRING . '(255) NULL',
            'phone'                 => Schema::TYPE_STRING . '(255) NULL',
            'email'                 => Schema::TYPE_STRING . '(255) NULL',
            'text'                  => Schema::TYPE_TEXT . ' NOT NULL',

            'url'                   => Schema::TYPE_STRING . '(255) NULL',

            //'files'                 => Schema::TYPE_TEXT. ' NULL',

            //'user_id'               => Schema::TYPE_INTEGER. ' NULL',
            //'priority'              => Schema::TYPE_INTEGER . '  NOT NULL DEFAULT 0',

            'status'                => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 10', //статус, активна некативна, удалено

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(updated_by);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(created_by);");

        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(created_at);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(updated_at);");

        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(phone);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(email);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(text(255));");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(url);");
        $this->execute("ALTER TABLE {{%reviews}} ADD INDEX(status);");
        //$this->execute("ALTER TABLE {{%reviews}} ADD INDEX(user_id);");
        //$this->execute("ALTER TABLE {{%reviews}} ADD INDEX(priority);");

        $this->execute("ALTER TABLE {{%reviews}} COMMENT = 'Отзывы';");

        $this->addForeignKey(
            'reviews_created_by', "{{%reviews}}",
            'created_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );

        $this->addForeignKey(
            'reviews_updated_by', "{{%reviews}}",
            'updated_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );

        /*
         $this->addForeignKey(
            'reviews_user_id', "{{%reviews}}",
            'user_id', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );
        */
    }

    public function down()
    {
        $this->dropForeignKey("reviews_created_by", "{{%reviews}}");
        $this->dropForeignKey("reviews_updated_by", "{{%reviews}}");
        //$this->dropForeignKey("reviews_user_id", "{{%reviews}}");

        $this->dropTable("{{%reviews}}");
    }
    
    /*
    // Use safeUp/safeDown to run migration code within a transaction
    public function safeUp()
    {
    }
    
    public function safeDown()
    {
    }
    */
}
