<?php
namespace skeeks\modules\cms\reviews\widgets\reviews;


use skeeks\cms\models\Publication;
use skeeks\cms\models\Search;
use skeeks\cms\widgets\base\hasModelsSmart\WidgetHasModelsSmart;

use skeeks\cms\base\Widget;
use skeeks\modules\cms\reviews\models\Reviews as ReviewsModel;
use skeeks\cms\models\Tree;
use skeeks\cms\widgets\WidgetHasTemplate;
use skeeks\cms\widgets\base\hasModels\WidgetHasModels;
use Yii;
use yii\helpers\ArrayHelper;
use yii\data\Pagination;

/**
 * Class Reviews
 * @package skeeks\cms\widgets\Reviews
 */
class Reviews extends WidgetHasModelsSmart //\skeeks\cms\widgets\base\hasTemplate\WidgetHasTemplate
{
    public $modelClassName          = '\skeeks\modules\cms\reviews\models\Reviews';


    /**
     * @var null|string
     */
    public $title                   = '';
    public $statuses                   = [];


    public function rules()
    {
        return ArrayHelper::merge(parent::rules(), [
            [['title'], 'string'],
            [['statuses'], 'safe'],
        ]);
    }


    /**
     * Подготовка данных для шаблона
     * @return $this
     */
    public function bind()
    {
        parent::bind();
        $dataProvider = $this->getSearch()->getDataProvider();
        $find = $dataProvider->query;
        //$find = ReviewsModel::find();

        if ($this->limit)
        {
            $find->limit($this->limit);
        }
        if ($this->statuses)
        {
            $find->andWhere(['status' => $this->statuses]);
        }

        return $this;
    }
}
